﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WinMaskEditBox
{
    public partial class Form1 : Form
    {
         char[] maskedChart = new char[] { '#', '/', '\\', '&', '>', '<', 'A', 'a', '9', 'C', '?' };
         char[] otherChartInMask;
         List<int> lenghtGroup = new List<int>();
        public Form1()
        {
            InitializeComponent();
            string s = ultraMaskedEdit1.InputMask;
            char ch = '\n';
            foreach (char c in maskedChart)
               s = s.Replace(c,ch);
            string st = "";
            st = st + ch;
            otherChartInMask = s.Replace(st, "").ToCharArray();
            s = ultraMaskedEdit1.InputMask;
            for (int i = 0; i < otherChartInMask.Length; i++)
            {
                lenghtGroup.Add(s.Substring(0,s.IndexOf(otherChartInMask[i])).Length);
                s = s.Substring(s.IndexOf(otherChartInMask[i])+1);
            }
        }

       

        private void ultraMaskedEdit1_MouseClick(object sender, MouseEventArgs e)
        {
            int br = 0;
            int selStart = ultraMaskedEdit1.Text.Length - otherChartInMask.Length;
            int lenghtGroupSum = 0;
            bool _continue = true;

            for (int i = 0; i < lenghtGroup.Count; i++)
            {
                lenghtGroupSum += lenghtGroup[br];
                if (selStart > lenghtGroupSum && _continue)
                    br++;
                else
                    _continue = false;
            }

            ultraMaskedEdit1.SelectionStart = selStart + br; 
        }

       
    }
}
